unit unitMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  Grids, ExtCtrls
  , Clipbrd, Buttons, UniqueInstance
  , inifiles
  , strutils
  , process, simpleipc
  , UniqueInstanceRAW
  , LclIntf, LMessages, LclType, LResources
  ;

type TFuses = record
   Signature1:Byte;
   Signature2:Byte;
   Signature3:Byte;
   LockByte:Byte;
   LowByte:Byte;
   HighByte:Byte;
   Calibration:string;
   Read_Signature:boolean;
   Read_LockByte:boolean;
   Read_LowByte:boolean;
   Read_HighByte:boolean;
   Read_Calibration:boolean;
end;

type TProgrammer = record
   name:string;
   BaudRate:integer;
   Delay:integer;
   Port:string;
end;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn10: TBitBtn;
    BitBtn11: TBitBtn;
    BitBtn12: TBitBtn;
    BitBtn13: TBitBtn;
    BitBtn14: TBitBtn;
    BitBtn15: TBitBtn;
    BitBtn16: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    ComboBox10: TComboBox;
    ComboBox11: TComboBox;
    ComboBox12: TComboBox;
    ComboBox13: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    ComboBox9: TComboBox;
    Device: TEdit;
    Label31: TLabel;
    Label32: TLabel;
    Memo4: TMemo;
    PfadEEPROM: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    SimpleIPCClient1: TSimpleIPCClient;
    SimpleIPCServer1: TSimpleIPCServer;
    SramSize: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label9: TLabel;
    LockByte: TEdit;
    FuseLowByte: TEdit;
    FuseHighByte: TEdit;
    Filename: TEdit;
    DeviceID: TEdit;
    FlashSize: TEdit;
    EEPromSize: TEdit;
    ImageList1: TImageList;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Signature: TEdit;
    PageControl1: TPageControl;
    CalibrationBytes: TEdit;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    StartTimer: TTimer;
    TabSheet4: TTabSheet;
    {$ifdef linux}
    MyTimer : ttimer;
    {$endif} {unix}

    procedure BitBtn10Click(Sender: TObject);
    procedure BitBtn12Click(Sender: TObject);
    procedure BitBtn14Click(Sender: TObject);
    procedure BitBtn15Click(Sender: TObject);
    procedure BitBtn16Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox7Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure SimpleIPCServer1Message(Sender: TObject);
    procedure SimpleIPCServer1MessageQueued(Sender: TObject);
    procedure StartTimerTimer(Sender: TObject);


    function READ_FUSES(SDeviceID:string): TFuses;
    procedure READ_FLASH(SDevice: string);
    procedure READ_EEPROM(SDevice: string);
    procedure SHOW_iHEX(SData: TStrings; var Grid: TStringGrid; inverted:boolean);
    procedure SHOW_rawHEX(DateiName: String; var Grid: TStringGrid);
    Procedure SET_FUSES_TO_COMBO;
    Procedure REVERSE_BYTE_SEQUENCE(var Grid: TStringGrid);
    procedure WIPE_GRID(var Grid: TStringGrid);

    procedure Start(Param1, Param2:string);

  private
    DatDir:string;
    TmpFileDir:string;
    DudeWrapperINI:TIniFile;
    DATINI:TIniFile;
    Fuses:TFuses;
    Programmer:TProgrammer;
    ParamStr1, ParamStr2 : string;
    Abbruch:boolean;

    {$IFDEF windows}
    avrdude_path:string;
    {$else} {unix}
    procedure receivemessage(Sender: TObject);
    {$ENDIF}

  public

  end;

var
  Form1: TForm1;
  ActivationMessage: UINT;

Const
  // Ein eigener GUID, dazu im Quelltexteditor [STRG+SHIFT+G] drücken
  MyGUID = '{CC8C7516-D6CA-4938-B494-937D7197D8F1}';
  KeywordLinkStart='[';
  KeywordLinkEnd=']';


implementation

uses unitProgrammer;

{$R *.lfm}

{ TForm1 }

//  Z:\usr\bin\avrdudeZ:\usr\bin\avrdude
//  -p {CHIP} -P '+Programmer.Port+' -c '+Programmer.name+' -b '+inttostr(Programmer.BaudRate)+' -U flash:w:"C:\X1\REV4\IQ-X1-Ver4_8MHz.hex":i

{$ifdef mswindows}
{$else} {unix}
procedure TForm1.receivemessage(Sender: TObject);
begin
   if SimpleIPCServer1.PeekMessage(1,True) then
   begin
     SimpleIPCServer1Message(Self);
   end;
//     Memo1.Append(SimpleIPCServer1.StringMessage);
end;
{$endif}


procedure TForm1.Start(Param1, Param2:string);
var
  AProcess:TProcess;
  Liste:TStringlist;
begin
  Pagecontrol1.ActivePage:=Tabsheet1;
  Device.text := Param1;
//  Filename.text:=stringreplace(Filename.text,'C:\',getuserdir+'.wine/drive_c/',[rfreplaceall]);
//  Filename.text:=stringreplace(Filename.text,'\','/',[rfreplaceall]);

  {$IFDEF Linux}
  {$else}
  {$ENDIF}

  {$IFDEF Linux}
  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:='winepath -u  '+Param2;
  AProcess.Options:=[poWaitOnExit,poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  Liste:=TStringlist.create;
  Liste.LoadFromStream(AProcess.Output);
  if liste.count = 1 then
    Filename.text := liste[0]
  else
    Filename.text := Param2;
  AProcess.free;
  Liste.free;
  {$else}
  Filename.text := Param2;
  {$ENDIF}

  DeviceID.text:='';
  FlashSize.text:='';
  EEPromSize.text:='';
  PfadEEPROM.text:='';
  TmpFileDir:=extractfiledir(application.ExeName) + PathDelim+ 'HexFiles';
  if not directoryexists(TmpFileDir) then
    mkdir(TmpFileDir);
  TmpFileDir:=TmpFileDir+pathdelim;
end;


procedure TForm1.FormShow(Sender: TObject);
begin
  if Abbruch=false then
  begin
    Start( Paramstr(1), Paramstr(2));
    StartTimer.enabled:=true;
  end;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  //Memo1.clear;
  //Memo2.clear;
end;

procedure TForm1.SimpleIPCServer1Message(Sender: TObject);
var
  str:string;
  Liste:TStringlist;
  i, code:integer;
begin
  str:=SimpleIPCServer1.StringMessage;
  application.ProcessMessages;
  if pos('PARAMS', str) > 0 then begin
    Liste:=TStringlist.Create;
    Liste.Delimiter:=';';
    Liste.StrictDelimiter:=true;
    Liste.DelimitedText:=str;
    If Liste.Count = 3 then
    begin
      START( Liste[1], Liste[2]);
      StartTimer.Enabled:=true;
    end;
    Liste.free;
  end;
end;


procedure TForm1.SimpleIPCServer1MessageQueued(Sender: TObject);
begin
  // Wird bei neuer Message aufgerufen... Starte LESEN der Message
  SimpleIPCServer1.PeekMessage(1, true);
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  DudeWrapperINI.Free;
  if DATINI <> NIL then
    DATINI.free;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
  Abbruch:=false;
  // Message registrieren bzw. ID holen
  SimpleIPCClient1.ServerID:=inttostr(WM_USER + 1);

  if InstanceRunning then begin
        if ParamCount > 0 then
        begin
           ParamStr1:=ParamStr(1);
           ParamStr2:=ParamStr(2);
           SimpleIPCClient1.Active:=True;
           SimpleIPCClient1.SendStringMessage( 'PARAMS;'+ParamStr1+';'+ParamStr2);
           SimpleIPCClient1.Active:=False;
        end;
        Abbruch:=true;
        application.terminate;
        exit;
  end;
  {$ifdef mswindows}
  {$else} {unix}
  MyTimer := TTimer.Create(nil); {In Linux no event occurs in MessageQueued. Trigger receivemessage by timer}
  MyTimer.Interval := 300;
  MyTimer.OnTimer := @form1.receivemessage;
  SimpleIPCServer1.OnMessage:=nil;
  SimpleIPCServer1.OnMessageQueued:=nil;
  SimpleIPCServer1.MaxQueue:=1;
  SimpleIPCServer1.ThreadTimeOut:=1000;
  {$endif}

  SimpleIPCServer1.ServerID:=inttostr(WM_USER + 1);
  SimpleIPCServer1.Global:=true;
  SimpleIPCServer1.Active:=true;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  screen.cursor:=crhourglass;
  Fuses:=READ_FUSES(Device.Text);
  if Fuses.Read_LockByte then
    LockByte.text:='0x'+format('%0.2x',[Fuses.LockByte])
  else
    LockByte.text:='?';
  if Fuses.Read_LowByte then
    FuseLowByte.text:='0x'+format('%0.2x',[Fuses.LowByte])
  else
    FuseLowByte.text:='?';
  if Fuses.Read_HighByte then
    FuseHighByte.text:='0x'+format('%0.2x',[Fuses.HighByte])
  else
    FuseHighByte.text:='?';
  if Fuses.Read_Signature then
    Signature.text:='0x'+format('%0.2x%0.2x%0.2x',[Fuses.Signature1,Fuses.Signature2,Fuses.Signature3])
  else
    Signature.text:='?';
  DeviceID.text:='0x'+format('%0.2x%0.2x%0.2x',[Fuses.Signature1,Fuses.Signature2,Fuses.Signature3]);
  if Fuses.Read_Calibration then
    CalibrationBytes.text:=Fuses.Calibration
  else
    CalibrationBytes.text:='?';
  SET_FUSES_TO_COMBO;
  screen.cursor:=crdefault;
end;

procedure TForm1.BitBtn10Click(Sender: TObject);
begin
  Panel1.visible:=false;
end;

procedure TForm1.BitBtn12Click(Sender: TObject);
var
  Liste:TSTringlist;
begin
  OpenDialog1.DefaultExt:='.eep';
  OpenDialog1.Filter:='EEP|*.eep';
  OpenDialog1.InitialDir:=GetUserDir;
  if OpenDialog1.Execute then
    begin
       PfadEEPROM.text:=OpenDialog1.FileName;
       Memo1.Text:='Öffne: '+OpenDialog1.FileName;
       Liste:=TSTringlist.create;
       Liste.LoadFromFile(OpenDialog1.FileName);
       if (Liste.count > 0)and(copy(Liste[0],1,1) = ':') then
         SHOW_iHEX(Liste, StringGrid2, true)
       else
         SHOW_rawHEX(OpenDialog1.FileName, StringGrid2);
       Liste.free;
       BitBtn14.visible:=true;
    end;
end;

procedure TForm1.BitBtn14Click(Sender: TObject);
var
  AProcess:TProcess;
  Liste:TSTringlist;
  x:integer;
  str:string;
begin
  Liste:=TSTringlist.create;

  if uppercase(extractfileext(PfadEEPROM.text))='.EEP' then
    str:='r'  // Rawbyte
  else
    str:='a'; // Automatic
  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:=avrdude_path+' -p '+Device.text+' -P '+Programmer.Port+' -c '+Programmer.name+' -b '+inttostr(Programmer.BaudRate)+' -U ''eeprom:w:'+trim(PfadEEPROM.text)+':'+str+'''';
  AProcess.Options:=[poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  str:='';
  memo1.clear;
  while AProcess.Running do
  begin
     Liste.LoadFromStream(AProcess.Output);
     str:=str+Liste.text;
     {$IFDEF Linux}
     str:=stringreplace(str,'#'+#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#10,'| ',[rfreplaceall]);
     memo1.text:=str;
     memo1.SelStart:=memo1.Lines.Text.Length-1;
     //memo1.SelLength:=1;
     //memo1.ClearSelection;
     {$else}
     str:=stringreplace(str,'#'+#13#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#13#10,'| ',[rfreplaceall]);
     memo1.text:=str;
     memo1.SelStart:=memo1.Lines.Text.Length-1;
     {$ENDIF}
     application.ProcessMessages;
  end;
  Liste.LoadFromStream(AProcess.Output);
  memo1.text:=memo1.text+Liste.text;
  memo1.SelStart:=memo1.Lines.Text.Length-1;

  AProcess.free;
  Liste.free;
end;

procedure TForm1.BitBtn15Click(Sender: TObject);
var
  AProcess:TProcess;
  Liste:TSTringlist;
  x:integer;
  str:string;
begin
  screen.cursor:=crhourglass;
  Liste:=TSTringlist.create;

  Memo3.clear;
  Panel1.left:=2;
  BitBtn10.visible:=false;
  Panel1.visible:=true;
  application.ProcessMessages;

  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:=avrdude_path+' -p '+Device.text+' -P '+Programmer.Port+' -c '+Programmer.name+' -O';
  AProcess.Options:=[poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  str:='************************************************' +#13+
       '* Perform a RC oscillator run-time calibration *' +#13+
       '************************************************' +#13+#13;
  while AProcess.Running do
  begin
     Liste.LoadFromStream(AProcess.Output);
     str:=str+Liste.text;
     str:=stringreplace(str,'#'+#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#10,'| ',[rfreplaceall]);

     memo3.text:=str;
     sleep(50);
     application.ProcessMessages;
  end;
  BitBtn1Click(Self);

  BitBtn10.visible:=true;
  screen.cursor:=crdefault;

  AProcess.free;
  Liste.free;
end;

procedure TForm1.BitBtn16Click(Sender: TObject);
begin
  Form3.Programmer.Text:=Programmer.name;
  Form3.Port.Text:=Programmer.Port;
  Form3.BaudRate.Text:=inttostr(Programmer.BaudRate);
  Form3.Delay.Value:=Programmer.Delay;
  Form3.Edit2.text:=DatDir;
  Form3.showmodal;
  if form3.tag = 1 then
  begin
     if pos(#9,Form3.Programmer.Text) > 0 then
       Programmer.name:=copy(Form3.Programmer.Text,1,pos(#9,Form3.Programmer.Text)-1)
     else
     if pos(' ',Form3.Programmer.Text) > 0 then
       Programmer.name:=copy(Form3.Programmer.Text,1,pos(' ',Form3.Programmer.Text)-1)
     else
       Programmer.name:=Form3.Programmer.Text;
     Programmer.Port:=Form3.Port.Text;
     Programmer.BaudRate:=strtointdef(Form3.BaudRate.Text, 115200);
     Programmer.Delay:=Form3.Delay.Value;


     DatDir:=trim(Form3.Edit2.text);
     DudeWrapperINI.WriteString('Setup','Dat Dir', DatDir);

     DudeWrapperINI.WriteString('Programmer','Name', Programmer.name);
     DudeWrapperINI.WriteString('Programmer','Port', Programmer.Port);
     DudeWrapperINI.WriteInteger('Programmer','BaudRate', Programmer.BaudRate);
     DudeWrapperINI.WriteInteger('Programmer','Delay', Programmer.Delay);
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  screen.cursor:=crhourglass;
  READ_FLASH(Device.text);
  screen.cursor:=crdefault;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  screen.cursor:=crhourglass;
  BitBtn14.visible:=false;
  READ_EEPROM(Device.text);
  screen.cursor:=crdefault;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var
  Liste:TSTringlist;
begin
  OpenDialog1.DefaultExt:='.hex';
  OpenDialog1.Filter:='HEX|*.hex';
  OpenDialog1.InitialDir:=GetUserDir;
  if OpenDialog1.Execute then
    begin
       Filename.text:=OpenDialog1.FileName;
       Memo2.Text:='Öffne: '+OpenDialog1.FileName;
       Liste:=TSTringlist.create;
       Liste.LoadFromFile(OpenDialog1.FileName);
       SHOW_iHEX(Liste, StringGrid1, checkbox1.checked);
       Liste.free;
    end;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
var
  AProcess:TProcess;
  Liste:TSTringlist;
  x:integer;
  str:string;
begin
  screen.cursor:=crhourglass;
  Liste:=TSTringlist.create;

  if Sender = BitBtn11 then
  begin
    Memo3.clear;
    Panel1.left:=2;
    BitBtn10.visible:=false;
    Panel1.visible:=true;
  end else begin
    memo2.clear;
  end;
  application.ProcessMessages;

  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:=avrdude_path+' -p '+Device.text+' -P '+Programmer.Port+' -c '+Programmer.name+' -e';
  AProcess.Options:=[poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  str:='';
  while AProcess.Running do
  begin
     Liste.LoadFromStream(AProcess.Output);
     str:=str+Liste.text;
     {$IFDEF Linux}
      str:=stringreplace(str,'#'+#10,'#',[rfreplaceall]);
      str:=stringreplace(str,'| '+#10,'| ',[rfreplaceall]);
      if Sender = BitBtn11 then
      begin
        memo3.text:=str;
        memo3.SelStart:=memo3.Lines.Text.Length-1;
        //memo3.SelLength:=1;
        //memo3.ClearSelection;
      end else begin
        memo2.text:=str;
        memo2.SelStart:=memo2.Lines.Text.Length-1;
        //memo2.SelLength:=1;
        //memo2.ClearSelection;
      end;
     {$else}
      str:=stringreplace(str,'#'+#13#10,'#',[rfreplaceall]);
      str:=stringreplace(str,'| '+#13#10,'| ',[rfreplaceall]);
      if Sender = BitBtn11 then
      begin
        memo3.text:=str;
        memo3.SelStart:=memo3.Lines.Text.Length-1;
      end else begin
        memo2.text:=str;
        memo2.SelStart:=memo2.Lines.Text.Length-1;
      end;
     {$ENDIF}
     application.ProcessMessages;
  end;
  Liste.LoadFromStream(AProcess.Output);
  if Sender = BitBtn11 then
    memo3.text:=memo3.text+Liste.text
  else
    memo2.text:=memo2.text+Liste.text;
  memo2.SelStart:=memo2.Lines.Text.Length-1;


  BitBtn1Click(Self);
  ComboBox1Change(Self);
  ComboBox4Change(Self);
  ComboBox7Change(Self);
  Stringgrid1.RowCount:=1;
  Stringgrid2.RowCount:=1;

  BitBtn10.visible:=true;
  screen.cursor:=crdefault;

  AProcess.free;
  Liste.free;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
var
  AProcess:TProcess;
  Liste:TSTringlist;
  x:integer;
  str:string;
begin
  Liste:=TSTringlist.create;

  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:=avrdude_path+' -p '+Device.text+' -P '+Programmer.Port+' -c '+Programmer.name+' -b '+inttostr(Programmer.BaudRate)+' -U flash:w:"'+trim(Filename.text)+'":i';
  AProcess.Options:=[poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  str:='';
  memo2.clear;
  while AProcess.Running do
  begin
     Liste.LoadFromStream(AProcess.Output);
     str:=str+Liste.text;
     {$IFDEF Linux}
     str:=stringreplace(str,'#'+#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#10,'| ',[rfreplaceall]);
     memo2.text:=str;
     memo2.SelStart:=memo2.Lines.Text.Length-1;
     //memo2.SelLength:=1;
     //memo2.ClearSelection;
     {$else}
     str:=stringreplace(str,'#'+#13#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#13#10,'| ',[rfreplaceall]);
     memo2.text:=str;
     memo2.SelStart:=memo2.Lines.Text.Length-1;
     {$ENDIF}
     application.ProcessMessages;
  end;
  Liste.LoadFromStream(AProcess.Output);
  memo2.text:=memo2.text+Liste.text;
  memo2.SelStart:=memo2.Lines.Text.Length-1;

  // Check, ob eep File vorhanden...
  str:=extractfileext(Filename.text);
  str:=copy(Filename.text,1,length(Filename.text)-length(str))+'.eep';
  if fileexists(str) then
  begin
    if MessageDlg('Soll die EEPROM Datei ebenfalls geflasht werden?', mtConfirmation, [mbOk, mbCancel], 0) = mrOk then
    begin
       PfadEEPROM.Text:=str;
       Pagecontrol1.ActivePage:=Tabsheet2;
       application.ProcessMessages;
       BitBtn14Click(self);
    end;
  end;

  AProcess.free;
  Liste.free;
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
var
  AProcess:TProcess;
  Liste:TSTringlist;
  x:integer;
  str:string;
begin
  screen.cursor:=crhourglass;
  Liste:=TSTringlist.create;

  Memo3.clear;
  Panel1.left:=2;
  BitBtn10.visible:=false;
  Panel1.visible:=true;
  application.ProcessMessages;

  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:=avrdude_path+' -p '+Device.text+' -P '+Programmer.Port+' -c '+Programmer.name+' -U lock:w:'+copy(label20.caption,1,4)+':m';
  AProcess.Options:=[poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  str:='**********************' +#13+
       '* Schreibe LOCK Bits *' +#13+
       '**********************' +#13+#13;
  while AProcess.Running do
  begin
     Liste.LoadFromStream(AProcess.Output);
     str:=str+Liste.text;
     str:=stringreplace(str,'#'+#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#10,'| ',[rfreplaceall]);

     Memo3.text:=str;
     Memo3.VertScrollBar.Position:=100000;
     sleep(10);
     application.ProcessMessages;
  end;

  BitBtn1Click(Self);
  ComboBox1Change(Self);
  BitBtn10.visible:=true;
  screen.cursor:=crdefault;
  AProcess.free;
  Liste.free;
end;

procedure TForm1.BitBtn8Click(Sender: TObject);
var
  AProcess:TProcess;
  Liste:TSTringlist;
  x:integer;
  str:string;
begin
  screen.cursor:=crhourglass;
  Liste:=TSTringlist.create;

  Memo3.clear;
  Panel1.left:=2;
  BitBtn10.visible:=false;
  Panel1.visible:=true;
  application.ProcessMessages;

  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:=avrdude_path+' -p '+Device.text+' -P '+Programmer.Port+' -c '+Programmer.name+' -U lfuse:w:'+copy(label21.caption,1,4)+':m';
  AProcess.Options:=[poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  str:='**************************' +#13+
       '* Schreibe Fuse LOW Bits *' +#13+
       '**************************' +#13+#13;
  while AProcess.Running do
  begin
     Liste.LoadFromStream(AProcess.Output);
     str:=str+Liste.text;
     str:=stringreplace(str,'#'+#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#10,'| ',[rfreplaceall]);

     Memo3.text:=str;
     Memo3.VertScrollBar.Position:=100000;
     sleep(10);
     application.ProcessMessages;
  end;
  BitBtn1Click(Self);
  ComboBox4Change(Self);
  BitBtn10.visible:=true;
  screen.cursor:=crdefault;
  AProcess.free;
  Liste.free;
end;

procedure TForm1.BitBtn9Click(Sender: TObject);
var
  AProcess:TProcess;
  Liste:TSTringlist;
  x:integer;
  str:string;
begin
  screen.cursor:=crhourglass;
  Liste:=TSTringlist.create;

  Memo3.clear;
  Panel1.left:=2;
  Panel1.visible:=true;
  application.ProcessMessages;

  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:=avrdude_path+' -p '+Device.text+' -P '+Programmer.Port+' -c '+Programmer.name+' -U hfuse:w:'+copy(label26.caption,1,4)+':m';
  AProcess.Options:=[poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  str:='***************************' +#13+
       '* Schreibe Fuse HIGH Bits *' +#13+
       '***************************' +#13+#13;
  while AProcess.Running do
  begin
     Liste.LoadFromStream(AProcess.Output);
     str:=str+Liste.text;
     str:=stringreplace(str,'#'+#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#10,'| ',[rfreplaceall]);

     Memo3.text:=str;
     Memo3.VertScrollBar.Position:=100000;
     sleep(10);
     application.ProcessMessages;
  end;
  BitBtn1Click(Self);
  screen.cursor:=crdefault;
  AProcess.free;
  Liste.free;
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  DudeWrapperINI.Writebool('Setup','little Endian', checkbox1.checked);
  REVERSE_BYTE_SEQUENCE(Stringgrid1);
end;

procedure TForm1.READ_FLASH(SDevice: string);
var
  AProcess:TProcess;
  Liste:TSTringlist;
  x, readpos, row_hex, offset, y, col_pos:integer;
  str, str2, str3:string;
  Mycolumn:TGridColumn;
begin
  Liste:=TSTringlist.create;

  WIPE_GRID( Stringgrid1);
  if fileexists(TmpFileDir+'Flash.hex') then
  begin
    deletefile(TmpFileDir+'Flash.hex');
  end;

  str:='';
  memo2.clear;
  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:=avrdude_path+' -p '+SDevice+' -P '+Programmer.Port+' -c '+Programmer.name+' -b '+inttostr(Programmer.BaudRate)+' -i '+inttostr(Programmer.Delay)+' -U flash:r:'+TmpFileDir+'Flash.hex:i';
  AProcess.Options:=[poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  while AProcess.Running do
  begin
     Liste.LoadFromStream(AProcess.Output);
     str:=str+Liste.text;
     {$IFDEF Linux}
     str:=stringreplace(str,'#'+#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#10,'| ',[rfreplaceall]);
     memo2.text:=str;
     memo2.SelStart:=memo2.Lines.Text.Length-1;
     //memo2.SelLength:=1;
     //memo2.ClearSelection;
     {$else}
     str:=stringreplace(str,'#'+#13#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#13#10,'| ',[rfreplaceall]);
     memo2.text:=str;
     memo2.SelStart:=memo2.Lines.Text.Length-1;
     {$ENDIF}
     memo2.Update;
  end;
  Liste.LoadFromStream(AProcess.Output);
  memo2.text:=trim(memo2.text)+trim(Liste.text);
  memo2.SelStart:=memo2.Lines.Text.Length-1;

  if fileexists(TmpFileDir+'Flash.hex') then
  begin
    Liste.LoadFromFile(TmpFileDir+'Flash.hex');
    SHOW_iHEX(Liste, StringGrid1, checkbox1.checked);
  end;

  AProcess.free;
  Liste.free;
end;

Procedure TForm1.REVERSE_BYTE_SEQUENCE(var Grid: TStringGrid);
var
  x:integer;
  row_pos, col_pos : integer;
  str1, str2:string;
begin
  for row_pos := 1 to Grid.RowCount -1 do
  begin
     Grid.Cells[17,row_pos]:='';
     for col_pos := 0 to 7 do
     begin
        str1:=Grid.Cells[(col_pos*2)+1,row_pos];
        str2:=Grid.Cells[(col_pos*2)+2,row_pos];
        Grid.Cells[(col_pos*2)+1,row_pos]:=str2;
        Grid.Cells[(col_pos*2)+2,row_pos]:=str1;
        if str2 <> '' then
          Grid.Cells[17,row_pos]:=Grid.Cells[17,row_pos]+chr( strtoint('$'+str2));
        if str1 <> '' then
          Grid.Cells[17,row_pos]:=Grid.Cells[17,row_pos]+chr( strtoint('$'+str1));
     end;
  end;
end;

procedure TForm1.SHOW_rawHEX(DateiName: String; var Grid: TStringGrid);
var
  x:integer;
  DateiStream:TMemoryStream;
  row_val, col_pos : integer;
  str:string;
  InByte:byte;
begin
  screen.cursor:=crhourglass;
  Grid.RowCount:=1;
  for x := 0 to 15 do
  begin
    Grid.Cells[x+1,0]:=format('%0.2x',[x]);
  end;
  Grid.Cells[17,0]:='          ASCII';
  Grid.FixedCols:=1;

  DateiStream:=TMemoryStream.Create;
  DateiStream.LoadFromFile(DateiName);
  DateiStream.Seek(0,0);

  for x := 0 to DateiStream.size-1 do
  begin
    if ((x mod 16)=0) then
    begin
      Grid.RowCount:=Grid.RowCount+1;
      Grid.cells[17,Grid.RowCount-1]:='';
      str:='';
      if x = 0 then
      begin
        row_val:=0;
      end else begin
        row_val:=row_val+$10;
      end;
      col_pos:=1;
      Grid.cells[0,Grid.RowCount-1]:='   '+format('%0.4x',[row_val]);
    end;
    InByte:=DateiStream.ReadByte;
    Grid.cells[col_pos,Grid.RowCount-1]:=format('%0.2x',[InByte]);
    Grid.cells[17,Grid.RowCount-1]:=Grid.cells[17,Grid.RowCount-1]+chr(InByte);
    inc(col_pos,1);
  end;

  DateiStream.Free;
  screen.cursor:=crdefault;
end;

procedure TForm1.WIPE_GRID(var Grid: TStringGrid);
var
 x:integer;
begin
  Grid.RowCount:=1;
  for x := 0 to 15 do
  begin
    Grid.Cells[x+1,0]:=format('%0.2x',[x]);
  end;
  Grid.Cells[17,0]:='          ASCII';
  Grid.FixedCols:=1;
end;

procedure TForm1.SHOW_iHEX(SData: TStrings; var Grid: TStringGrid; inverted:boolean);
var
   x, row_count, ByteCount, colptr, Adresse, y : integer;
   checksum , rowaddress: integer;
   rowStr, rowChars, checksum_warn : string;
   Data:array of string;
begin
// intel hex format
// StartCode
// | Byte Count
// | |  Adress
// | |  |    RecordType
// | |  |    |         Checksum
// | |  |    |         |
// : 10 0100 00 {DATA} 40

  screen.cursor:=crhourglass;

  WIPE_GRID( Grid);
  rowaddress:=0;
  for row_count := 0 to SData.count - 1 do
  begin
     rowStr := SData[row_count];
     // StartCode OK?
     if copy(rowStr,1,1) = ':' then
     begin
        ByteCount := strtoint('$'+ copy(rowStr,2,2));
        if ByteCount > 0 then
        begin
          setlength(Data, ByteCount);
          checksum:=0;
          for x := 0 to 3 do
          begin
             checksum:=checksum+strtoint('$'+copy(rowStr,(x*2)+2,2));
          end;
          for x := 0 to trunc(ByteCount/2)-1 do
          begin
             Data[(x*2)]  :=copy(rowStr,10+(x*4)+(ord( not inverted)*2),2);
             if Data[(x*2)] <> '' then
             begin
               checksum:=checksum+strtoint('$'+Data[(x*2)]);
             end;
             Data[(x*2)+1]:=copy(rowStr,10+(x*4)+(ord( inverted)*2),2);
             if Data[(x*2)+1] <> '' then
             begin
               checksum:=checksum+strtoint('$'+Data[(x*2)+1]);
             end;
          end;
          checksum:= (((checksum and $ff) xor %11111111) + 1) and $ff;
          rowChars:=copy(rowStr,length(rowStr)-1,2);
          if rowChars <> format('%0.2x',[checksum]) then
             checksum_warn:='!'
          else
             checksum_warn:=' ';
          colptr:=1;
  //        Grid.RowCount:=Grid.RowCount+1;
  //        Grid.Cells[0,Grid.RowCount-1]:='   '+copy(rowStr,4,4);
          Adresse:=strtoint('$'+copy(rowStr,4,4));
          Adresse := rowaddress + Adresse;
          if strtoint('$'+ copy(rowStr,8,2)) = 0 then
          begin
            for x := 0 to ByteCount-1 do
            begin
                  if (x mod 16 = 0) then
                  begin
                    rowChars:='';
                    Grid.RowCount:=Grid.RowCount+1;
                    Grid.Cells[17,Grid.RowCount-1]:='';
                    if x > 15 then
                      Adresse := Adresse + $10;
                    Grid.Cells[0,Grid.RowCount-1]:=checksum_warn+inttohex(Adresse,6);
                    colptr:=1;
                  end;
                  Grid.Cells[colptr,Grid.RowCount-1]:=Data[x];
                  Grid.cells[17,Grid.RowCount-1]:=Grid.cells[17,Grid.RowCount-1]+chr(strtoint('$'+Data[x]));

               inc(colptr,1);
            end;
          end else
          if strtoint('$'+ copy(rowStr,8,2)) = 2 then
          begin
             rowaddress:=((strtoint('$'+Data[0]) shl 8 ) + strtoint('$'+Data[1])) shl 4;
          end;
        end;
     end else begin
        ShowMessage('Kein gültiges "Intel HEX" Format!');
        break;
     end;
  end;
  screen.cursor:=crdefault;
end;



procedure TForm1.READ_EEPROM(SDevice: string);
var
  AProcess:TProcess;
  Liste:TSTringlist;
  x:integer;
  str:string;
begin
  Liste:=TSTringlist.create;

  WIPE_GRID( Stringgrid2);
  if fileexists(TmpFileDir+'EEProm.hex') then
  begin
    deletefile(TmpFileDir+'EEProm.hex');
  end;

  memo1.Clear;
  str:='';
  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:=avrdude_path+' -p '+SDevice+' -P '+Programmer.Port+' -c '+Programmer.name+' -b '+inttostr(Programmer.BaudRate)+' -i '+inttostr(Programmer.Delay)+' -U eeprom:r:'+TmpFileDir+'EEProm.hex:i';
  AProcess.Options:=[poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  while AProcess.Running do
  begin
     Liste.LoadFromStream(AProcess.Output);
     str:=str+Liste.text;
     {$IFDEF Linux}
     str:=stringreplace(str,'#'+#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#10,'| ',[rfreplaceall]);
     memo1.text:=str;
     memo1.SelStart:=memo1.Lines.Text.Length-1;
     //memo1.SelLength:=1;
     //memo1.ClearSelection;
     {$else}
     str:=stringreplace(str,'#'+#13#10,'#',[rfreplaceall]);
     str:=stringreplace(str,'| '+#13#10,'| ',[rfreplaceall]);
     memo1.text:=str;
     memo1.SelStart:=memo1.Lines.Text.Length-1;
     {$ENDIF}
     memo1.Update;
     // application.ProcessMessages;
  end;
  Liste.LoadFromStream(AProcess.Output);
  memo1.text:=trim(memo1.text)+trim(Liste.text);
  memo1.SelStart:=memo1.Lines.Text.Length-1;

  if fileexists(TmpFileDir+'EEProm.hex') then
  begin
    Liste.LoadFromFile(TmpFileDir+'EEProm.hex');
    SHOW_iHEX(Liste, StringGrid2, true);
  end;

  AProcess.free;
  Liste.free;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  Byte1:byte;
begin
  Byte1:=%11000000;

  if ComboBox1.Visible=true then
  begin
    if Combobox1.ItemIndex=0 then Byte1:=Byte1 or %11;
    if Combobox1.ItemIndex=1 then Byte1:=Byte1 or %10;
    if Combobox1.ItemIndex=2 then Byte1:=Byte1 or %00;
  end;

  if ComboBox2.Visible=true then
  begin
    if Combobox2.ItemIndex=0 then Byte1:=Byte1 or %1100;
    if Combobox2.ItemIndex=1 then Byte1:=Byte1 or %1000;
    if Combobox2.ItemIndex=2 then Byte1:=Byte1 or %0000;
    if Combobox2.ItemIndex=3 then Byte1:=Byte1 or %0100;
  end;

  if ComboBox3.Visible=true then
  begin
    if Combobox3.ItemIndex=0 then Byte1:=Byte1 or %110000;
    if Combobox3.ItemIndex=1 then Byte1:=Byte1 or %100000;
    if Combobox3.ItemIndex=2 then Byte1:=Byte1 or %000000;
    if Combobox3.ItemIndex=3 then Byte1:=Byte1 or %010000;
  end;

  Label20.caption:='0x'+format('%0.2x',[Byte1]) + '    ' +'%'+binStr(Byte1,8);
  Label20.tag:=Byte1;
  BitBtn7.visible:= (ComboBox1.Visible=true or ComboBox2.Visible=true or ComboBox3.Visible=true) and (copy(label20.caption,1,4) <> LockByte.text);

end;

procedure TForm1.ComboBox4Change(Sender: TObject);
var
  CKSEL, SUT:string;
  hlpStr:string;
  Byte1:byte;
begin
  Byte1:=%00000000;

  if ComboBox4.Visible=true then
  begin
    if Combobox4.ItemIndex=1 then Byte1:=Byte1 or %10000000;
  end;

  if ComboBox5.Visible=true then
  begin
    if Combobox5.ItemIndex=1 then Byte1:=Byte1 or %01000000;
  end;

  if ComboBox6.Visible=true then
  begin
    hlpStr:=Combobox6.items[Combobox6.itemindex];
    CKSEL:= copy(hlpSTr,pos('CKSEL',hlpStr)+6,4);
    SUT:= copy(hlpSTr,pos('SUT',hlpStr)+4,2);
    if copy(SUT,1,1) = '1' then Byte1:=Byte1 or %00100000;
    if copy(SUT,2,1) = '1' then Byte1:=Byte1 or %00010000;
    if copy(CKSEL,1,1) = '1' then Byte1:=Byte1 or %00001000;
    if copy(CKSEL,2,1) = '1' then Byte1:=Byte1 or %00000100;
    if copy(CKSEL,3,1) = '1' then Byte1:=Byte1 or %00000010;
    if copy(CKSEL,4,1) = '1' then Byte1:=Byte1 or %00000001;
  end;

  Label21.caption:='0x'+format('%0.2x',[Byte1]) + '    ' +'%'+binStr(Byte1,8);
  Label21.tag:=Byte1;
  BitBtn8.visible:= (ComboBox4.Visible=true or ComboBox5.Visible=true or ComboBox6.Visible=true) and (copy(label21.caption,1,4) <> FuseLowByte.text);

end;

procedure TForm1.ComboBox7Change(Sender: TObject);
var
  CKSEL, SUT:string;
  hlpStr:string;
  Byte1:byte;
begin
  Byte1:=%00000000;

  // Bit M
  if ComboBox7.Visible=true then
  begin
    if Combobox7.ItemIndex=1 then Byte1:=Byte1 or %10000000;
  end;
  // Bit J
  if ComboBox8.Visible=true then
  begin
    if Combobox8.ItemIndex=1 then Byte1:=Byte1 or %01000000;
  end;
  // Bit I
  if ComboBox9.Visible=true then
  begin
    if Combobox9.ItemIndex=1 then Byte1:=Byte1 or %00100000;
  end;
  // Bit H
  if ComboBox10.Visible=true then
  begin
    if Combobox10.ItemIndex=1 then Byte1:=Byte1 or %00010000;
  end;
  // Bit G
  if ComboBox11.Visible=true then
  begin
    if Combobox11.ItemIndex=1 then Byte1:=Byte1 or %00001000;
  end;
  // Bit FE
  if Combobox12.ItemIndex=0 then
    Byte1:=Byte1 or %00000110
  else
  if Combobox12.ItemIndex=1 then
    Byte1:=Byte1 or %00000100
  else
  if Combobox12.ItemIndex=2 then
    Byte1:=Byte1 or %00000010;
  // Bit D
  if ComboBox13.Visible=true then
  begin
    if Combobox13.ItemIndex=1 then Byte1:=Byte1 or %00000001;
  end;

  Label26.caption:='0x'+format('%0.2x',[Byte1]) + '    ' +'%'+binStr(Byte1,8);
  Label26.tag:=Byte1;
  BitBtn9.visible:= (ComboBox7.Visible=true or ComboBox7.Visible=true or ComboBox8.Visible=true or
                     ComboBox9.Visible=true  or ComboBox10.Visible=true or ComboBox11.Visible=true or
                     ComboBox12.Visible=true or ComboBox13.Visible=true) and (copy(label26.caption,1,4) <> FuseHighByte.text);
end;

function TForm1.READ_FUSES(SDeviceID:string):TFuses;
var
  Liste:TSTringlist;
  x:integer;
  str:string;
begin
  Liste:=TSTringlist.create;
  // Lösche altes File...
  if fileexists(TmpFileDir+'Signature.hex') then
    deletefile( TmpFileDir+'Signature.hex');
  // Lösche altes File...
  if fileexists(TmpFileDir+'Lock.hex') then
    deletefile( TmpFileDir+'Lock.hex');
  // Lösche altes File...
  if fileexists(TmpFileDir+'Calibration.hex') then
    deletefile( TmpFileDir+'Calibration.hex');
  // Lösche altes File...
  if fileexists(TmpFileDir+'HighByte.hex') then
    deletefile( TmpFileDir+'HighByte.hex');
  // Lösche altes File...
  if fileexists(TmpFileDir+'LowByte.hex') then
    deletefile( TmpFileDir+'LowByte.hex');

  RunCommand(
      avrdude_path+
      ' -p '+SDeviceID+
      ' -P '+Programmer.Port+
      ' -c '+Programmer.name+
      ' -b '+inttostr(Programmer.BaudRate)+
      ' -i '+inttostr(Programmer.Delay)+
      ' -U signature:r:'+TmpFileDir+'Signature.hex:h'+
      ' -U calibration:r:'+TmpFileDir+'Calibration.hex:h'+
      ' -U lock:r:'+TmpFileDir+'Lock.hex:h'+
      ' -U lfuse:r:'+TmpFileDir+'LowByte.hex:h'+
      ' -U hfuse:r:'+TmpFileDir+'HighByte.hex:h',
      str
      );

   result.Signature1:=0;
   result.Signature2:=0;
   result.Signature3:=0;
   if fileexists(TmpFileDir+'Signature.hex') then
   begin
     result.Read_Signature:=true;
     Liste.LoadFromFile(TmpFileDir+'Signature.hex');
     str:=uppercase(Liste[0]);
     Liste.Delimiter:=',';
     Liste.StrictDelimiter:=true;
     Liste.DelimitedText:=str;
     if Liste.Count > 0 then
     begin
       str:=stringreplace(uppercase(Liste[0]), '0X','',[rfreplaceall]);
       result.Signature1:=hex2dec(str);
     end;
     if Liste.Count > 1 then
     begin
       str:=stringreplace(uppercase(Liste[1]), '0X','',[rfreplaceall]);
       result.Signature2:=hex2dec(str);
     end;
     if Liste.Count > 2 then
     begin
       str:=stringreplace(uppercase(Liste[2]), '0X','',[rfreplaceall]);
       result.Signature3:=hex2dec(str);
     end;
   end else begin
      result.Read_Signature:=false;
   end;
   application.ProcessMessages;

   //RunCommand(
   //    avrdude_path+
   //    ' -p '+SDeviceID+
   //    ' -P '+Programmer.Port+
   //    ' -c '+Programmer.name+
   //    ' -b '+inttostr(Programmer.BaudRate)+
   //    ' -i '+inttostr(Programmer.Delay)+
   //    ' -U calibration:r:'+TmpFileDir+'Calibration.hex:h',
   //    str
   //    );
   result.Calibration:='0x ';
   if fileexists(TmpFileDir+'Calibration.hex') then
    begin
      result.Read_Calibration:=true;
      Liste.LoadFromFile(TmpFileDir+'Calibration.hex');
      str:=uppercase(Liste[0]);
      Liste.Delimiter:=',';
      Liste.StrictDelimiter:=true;
      Liste.DelimitedText:=str;
      for x := 0 to Liste.count - 1 do
      begin
        str:=stringreplace(uppercase(Liste[x]), '0X','',[rfreplaceall]);
        result.Calibration:=result.Calibration+format('%0.2x',[hex2dec(str)])+' ';
      end;
    end else begin
       result.Read_Calibration:=false;
    end;
   application.ProcessMessages;

   //RunCommand(
   //    avrdude_path+
   //    ' -p '+sDeviceID+
   //    ' -P '+Programmer.Port+
   //    ' -c '+Programmer.name+
   //    ' -b '+inttostr(Programmer.BaudRate)+
   //    ' -i '+inttostr(Programmer.Delay)+
   //    ' -U lock:r:'+TmpFileDir+'Lock.hex:h',
   //    str
   //    );
   result.LockByte:=0;
   if fileexists(TmpFileDir+'Lock.hex') then
   begin
     result.Read_LockByte:=true;
     Liste.LoadFromFile(TmpFileDir+'Lock.hex');
     str:=stringreplace(uppercase(Liste[0]), '0X','',[rfreplaceall]);
     result.LockByte:=hex2dec(str);
   end else begin
      result.Read_LockByte:=false;
   end;
   application.ProcessMessages;

   //RunCommand(
   //    avrdude_path+
   //    ' -p '+SDeviceID+
   //    ' -P '+Programmer.Port+
   //    ' -c '+Programmer.name+
   //    ' -b '+inttostr(Programmer.BaudRate)+
   //    ' -i '+inttostr(Programmer.Delay)+
   //    ' -U lfuse:r:'+TmpFileDir+'LowByte.hex:h',
   //    str
   //    );
   result.LowByte:=0;
   if fileexists(TmpFileDir+'LowByte.hex') then
   begin
     result.Read_LowByte:=true;
     Liste.LoadFromFile(TmpFileDir+'LowByte.hex');
     str:=stringreplace(uppercase(Liste[0]), '0X','',[rfreplaceall]);
     result.LowByte:=hex2dec(str);
   end else begin
      result.Read_LowByte:=false;
   end;
   application.ProcessMessages;

   //RunCommand(
   //    avrdude_path+
   //    ' -p '+SDeviceID+
   //    ' -P '+Programmer.Port+
   //    ' -c '+Programmer.name+
   //    ' -b '+inttostr(Programmer.BaudRate)+
   //    ' -i '+inttostr(Programmer.Delay)+
   //    ' -U hfuse:r:'+TmpFileDir+'HighByte.hex:h',
   //    str
   //    );
   result.HighByte:=0;
   if fileexists(TmpFileDir+'HighByte.hex') then
   begin
     result.Read_HighByte:=true;
     Liste.LoadFromFile(TmpFileDir+'HighByte.hex');
     str:=stringreplace(uppercase(Liste[0]), '0X','',[rfreplaceall]);
     result.HighByte:=hex2dec(str);
   end else begin
      result.Read_HighByte:=false;
   end;
   application.ProcessMessages;

   Liste.free;
end;

procedure TForm1.StartTimerTimer(Sender: TObject);
var
  DatFileName:string;
  hlpStr:string;
  DatListe:TSTringlist;
  x, y, TextWidth:integer;
  CKSEL, SUT, str:string;
  AProcess:TProcess;
  Liste:TStringlist;
begin
  StartTimer.enabled:=false;
  screen.cursor:=crhourglass;
  DatListe:=TSTringlist.Create;

  if Device.text = '' then
  begin
    Showmessage('Kein Device angegeben!'+
                #13 + #13+
                'Anwendung wird beendet.'
    );
    close;
  end;


  {$IFDEF Linux}
  AProcess:=TProcess.Create(nil);
  AProcess.CommandLine:='apt show avrdude';
  AProcess.Options:=[poWaitOnExit,poUsePipes,poStderrToOutPut];
  AProcess.Execute;
  Liste:=TStringlist.create;
  Liste.LoadFromStream(AProcess.Output);

  for x := 0 to Liste.count-1 do
  begin
    if  (Liste[x]='Package: avrdude') then
    begin
      break;
    end;
  end;

  if x =  Liste.count-1 then
  begin
    Clipboard.Clear;
    Clipboard.AsText := 'sudo apt-get install binutils gcc-avr avr-libc uisp avrdude';
    Showmessage('Bitte avrdude installieren!'+
                #13 + #13+
                Clipboard.AsText
    );
    close;
  end;
  avrdude_path:='avrdude';
  {$else}
  if fileexists(extractfilepath(application.ExeName)+'avrdude\avrdude.exe') then
  begin
    avrdude_path:=extractfilepath(application.ExeName)+'avrdude\avrdude.exe'
  end else begin
     Showmessage('Bitte avrdude installieren!');
     close;
     exit;
  end;

  {$ENDIF}



  str:=extractfiledir(application.ExeName)+Pathdelim+'DudeWrapper.ini';
  DudeWrapperINI:=TIniFile.Create(str);
  DatDir:=DudeWrapperINI.ReadString('Setup','Dat Dir', '');
  checkbox1.checked:=DudeWrapperINI.ReadBool('Setup','little Endian', true);
  Programmer.name:=DudeWrapperINI.ReadString('Programmer','Name', 'avrispmkII');
  Programmer.Port:=DudeWrapperINI.ReadString('Programmer','Port', 'usb');
  Programmer.BaudRate:=DudeWrapperINI.ReadInteger('Programmer','BaudRate', 115200);
  Programmer.Delay:=DudeWrapperINI.ReadInteger('Programmer','Delay', 100);

  if directoryexists(DatDir) = false then
  begin
    Showmessage('Bitte Verzeichnis "DAT" der Bascom Installation auswählen!' +#13+#13+
                '(evtl. über Rechtsklick im Explorer "hidden Files" aktivieren)'
    );
    BitBtn16Click(self);
    if directoryexists(DatDir) = false then
    begin
      Showmessage('Ohne gültiges Verzeichniss "DAT" der Bascom Installation, wird die Anwendung geschlossen!');
      close;
      exit;
    end;
  end;

  BitBtn1Click(self);
  Label20.caption:='';
  Label21.caption:='';

  hlpStr:=Device.text;
  hlpStr:=stringreplace(uppercase(hlpStr),'ATMEGA','m',[rfreplaceall]);
  DatFileName:= DatDir + PathDelim + hlpStr+'def.dat';
  if fileexists(DatFileName) then
  begin
    Memo4.lines.LoadFromFile(DatFileName);

    DATINI:=TIniFile.Create(DatFileName);
    FlashSize.Text:=trim(copy(DATINI.ReadString('DEVICE','FlashSizeText',''),1,10));
    EEPromSize.Text:=trim(copy(DATINI.ReadString('DEVICE','EEPROM',''),1,10));
    if strtointdef(EEPromSize.Text,-1) <> -1 then
      EEPromSize.Text:=EEPromSize.Text+ ' Byte  0x' + format('%0.4x',[ strtointdef(EEPromSize.Text,-1)-1]);
    SramSize.Text:=trim(copy(DATINI.ReadString('DEVICE','SRAM',''),1,10));
    if strtointdef(SramSize.Text,-1) <> -1 then
      SramSize.Text:=SramSize.Text+ ' Byte  0x' + format('%0.4x',[ strtointdef(SramSize.Text,-1)-1]);
    hlpStr:=DATINI.ReadString('PROG','readLB','');
    hlpStr:=copy(hlpStr,pos('FF',hlpStr)+3,length(hlpStr));

    Combobox1.ItemWidth:=200;
    if pos('21', hlpStr) > 0 then
    begin
      ComboBox1.Items.Clear;
      ComboBox1.Items.Add( trim( DATINI.ReadString('PROG','21-11','') ) );
      ComboBox1.Items.Add( trim( DATINI.ReadString('PROG','21-10','') ) );
      ComboBox1.Items.Add( trim( DATINI.ReadString('PROG','21-00','') ) );
      ComboBox1.Visible:=true;
      for x := 0 to Combobox1.Items.count-1 do
      begin
        TextWidth:=Combobox1.Canvas.GetTextWidth(Combobox1.items[x]);
        if combobox1.ItemWidth < TextWidth then
          combobox1.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox1.Visible:=false;
    end;

    Combobox2.ItemWidth:=200;
    if pos('43', hlpStr) > 0 then
    begin
      ComboBox2.Items.Clear;
      ComboBox2.Items.Add( trim( DATINI.ReadString('PROG','43-11','') ) );
      ComboBox2.Items.Add( trim( DATINI.ReadString('PROG','43-10','') ) );
      ComboBox2.Items.Add( trim( DATINI.ReadString('PROG','43-00','') ) );
      ComboBox2.Items.Add( trim( DATINI.ReadString('PROG','43-01','') ) );
      ComboBox2.Visible:=true;
      for x := 0 to Combobox2.Items.count-1 do
      begin
        TextWidth:=Combobox2.Canvas.GetTextWidth(Combobox2.items[x]);
        if combobox2.ItemWidth < TextWidth then
          combobox2.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox2.Visible:=false;
    end;


    Combobox3.ItemWidth:=200;
    if pos('65', hlpStr) > 0 then
    begin
      ComboBox3.Items.Clear;
      ComboBox3.Items.Add( trim( DATINI.ReadString('PROG','65-11','') ) );
      ComboBox3.Items.Add( trim( DATINI.ReadString('PROG','65-10','') ) );
      ComboBox3.Items.Add( trim( DATINI.ReadString('PROG','65-00','') ) );
      ComboBox3.Items.Add( trim( DATINI.ReadString('PROG','65-01','') ) );
      ComboBox3.Visible:=true;
      for x := 0 to Combobox3.Items.count-1 do
      begin
        TextWidth:=Combobox3.Canvas.GetTextWidth(Combobox3.items[x]);
        if combobox3.ItemWidth < TextWidth then
          combobox3.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox3.Visible:=false;
    end;


    hlpStr:=DATINI.ReadString('PROG','readFS','');
    hlpStr:=copy(hlpStr,pos('FF',hlpStr)+3,length(hlpStr));

    Combobox4.ItemWidth:=200;
    if pos('B', hlpStr) > 0 then
    begin
      ComboBox4.Items.Clear;
      ComboBox4.Items.Add( trim( DATINI.ReadString('PROG','B-0','') ) );
      ComboBox4.Items.Add( trim( DATINI.ReadString('PROG','B-1','') ) );
      ComboBox4.Visible:=true;
      for x := 0 to Combobox4.Items.count-1 do
      begin
        TextWidth:=Combobox4.Canvas.GetTextWidth(Combobox4.items[x]);
        if combobox4.ItemWidth < TextWidth then
          combobox4.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox4.Visible:=false;
    end;

    Combobox5.ItemWidth:=200;
    if pos('C', hlpStr) > 0 then
    begin
      ComboBox5.Items.Clear;
      ComboBox5.Items.Add( trim( DATINI.ReadString('PROG','C-0','') ) );
      ComboBox5.Items.Add( trim( DATINI.ReadString('PROG','C-1','') ) );
      ComboBox5.Visible:=true;
      for x := 0 to Combobox5.Items.count-1 do
      begin
        TextWidth:=Combobox5.Canvas.GetTextWidth(Combobox5.items[x]);
        if combobox5.ItemWidth < TextWidth then
          combobox5.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox4.Visible:=false;
    end;

    Combobox6.ItemWidth:=200;
    if pos('KLA987', hlpStr) > 0 then
    begin
      ComboBox6.Items.Clear;
      DATINI.ReadSection('PROG', DatListe);
      for x := 0 to DatListe.Count - 1 do
      begin
          if pos('KLA987', DatListe[x]) > 0 then
          begin
            ComboBox6.Items.Add( trim( DATINI.ReadString('PROG',DatListe[x],'') ) );
          end;
      end;
      ComboBox6.Visible:=true;
      for x := 0 to Combobox6.Items.count-1 do
      begin
        TextWidth:=Combobox6.Canvas.GetTextWidth(Combobox6.items[x]);
        if combobox6.ItemWidth < TextWidth then
          combobox6.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox6.Visible:=false;
    end;


    hlpStr:=DATINI.ReadString('PROG','readFSH','');
    hlpStr:=copy(hlpStr,pos('FF',hlpStr)+3,length(hlpStr));

    Combobox7.ItemWidth:=200;
    if pos('M', hlpStr) > 0 then
    begin
      ComboBox7.Items.Clear;
      ComboBox7.Items.Add( trim( DATINI.ReadString('PROG','M-0','') ) );
      ComboBox7.Items.Add( trim( DATINI.ReadString('PROG','M-1','') ) );
      ComboBox7.Visible:=true;
      for x := 0 to Combobox7.Items.count-1 do
      begin
        TextWidth:=Combobox7.Canvas.GetTextWidth(Combobox7.items[x]);
        if combobox7.ItemWidth < TextWidth then
          combobox7.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox7.Visible:=false;
    end;

    Combobox8.ItemWidth:=200;
    if pos('J', hlpStr) > 0 then
    begin
      ComboBox8.Items.Clear;
      ComboBox8.Items.Add( trim( DATINI.ReadString('PROG','J-0','') ) );
      ComboBox8.Items.Add( trim( DATINI.ReadString('PROG','J-1','') ) );
      ComboBox8.Visible:=true;
      for x := 0 to Combobox8.Items.count-1 do
      begin
        TextWidth:=Combobox8.Canvas.GetTextWidth(Combobox8.items[x]);
        if combobox8.ItemWidth < TextWidth then
          combobox8.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox8.Visible:=false;
    end;

    Combobox9.ItemWidth:=200;
    if pos('I', hlpStr) > 0 then
    begin
      ComboBox9.Items.Clear;
      ComboBox9.Items.Add( trim( DATINI.ReadString('PROG','I-0','') ) );
      ComboBox9.Items.Add( trim( DATINI.ReadString('PROG','I-1','') ) );
      ComboBox9.Visible:=true;
      for x := 0 to Combobox9.Items.count-1 do
      begin
        TextWidth:=Combobox9.Canvas.GetTextWidth(Combobox9.items[x]);
        if combobox9.ItemWidth < TextWidth then
          combobox9.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox9.Visible:=false;
    end;

    Combobox10.ItemWidth:=200;
    if pos('H', hlpStr) > 0 then
    begin
      ComboBox10.Items.Clear;
      ComboBox10.Items.Add( trim( DATINI.ReadString('PROG','H-0','') ) );
      ComboBox10.Items.Add( trim( DATINI.ReadString('PROG','H-1','') ) );
      ComboBox10.Visible:=true;
      for x := 0 to Combobox10.Items.count-1 do
      begin
        TextWidth:=Combobox10.Canvas.GetTextWidth(Combobox10.items[x]);
        if combobox10.ItemWidth < TextWidth then
          combobox10.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox10.Visible:=false;
    end;

    Combobox11.ItemWidth:=200;
    if pos('G', hlpStr) > 0 then
    begin
      ComboBox11.Items.Clear;
      ComboBox11.Items.Add( trim( DATINI.ReadString('PROG','G-0','') ) );
      ComboBox11.Items.Add( trim( DATINI.ReadString('PROG','G-1','') ) );
      ComboBox11.Visible:=true;
      for x := 0 to Combobox11.Items.count-1 do
      begin
        TextWidth:=Combobox11.Canvas.GetTextWidth(Combobox11.items[x]);
        if combobox11.ItemWidth < TextWidth then
          combobox11.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox11.Visible:=false;
    end;

    Combobox12.ItemWidth:=200;
    if pos('FE', hlpStr) > 0 then
    begin
      ComboBox12.Items.Clear;
      ComboBox12.Items.Add( trim( DATINI.ReadString('PROG','FE-11','') ) );
      ComboBox12.Items.Add( trim( DATINI.ReadString('PROG','FE-10','') ) );
      ComboBox12.Items.Add( trim( DATINI.ReadString('PROG','FE-01','') ) );
      ComboBox12.Items.Add( trim( DATINI.ReadString('PROG','FE-00','') ) );
      ComboBox12.Visible:=true;
      for x := 0 to Combobox12.Items.count-1 do
      begin
        TextWidth:=Combobox12.Canvas.GetTextWidth(Combobox12.items[x]);
        if combobox12.ItemWidth < TextWidth then
          combobox12.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox12.Visible:=false;
    end;

    Combobox13.ItemWidth:=200;
    if pos('D', hlpStr) > 0 then
    begin
      ComboBox13.Items.Clear;
      ComboBox13.Items.Add( trim( DATINI.ReadString('PROG','D-0','') ) );
      ComboBox13.Items.Add( trim( DATINI.ReadString('PROG','D-1','') ) );
      ComboBox13.Visible:=true;
      for x := 0 to Combobox13.Items.count-1 do
      begin
        TextWidth:=Combobox13.Canvas.GetTextWidth(Combobox13.items[x]);
        if combobox13.ItemWidth < TextWidth then
          combobox13.ItemWidth := TextWidth;
      end;
    end
    else begin
      ComboBox13.Visible:=false;
    end;
  end;
  SET_FUSES_TO_COMBO;
  ComboBox1Change(self);
  ComboBox4Change(self);
  ComboBox7Change(self);

  // wenn Filename übergeben wurde, dann lade Flash
  if (Filename.text <> '') then
  begin
    if(fileexists(Filename.text)) then
    begin
      Memo2.Text:='Öffne: '+Filename.text;
      DatListe.LoadFromFile(Filename.text);
      SHOW_iHEX(DatListe, StringGrid1, checkbox1.checked)
    end;
  end;
  // Check, ob eep File vorhanden...
  hlpStr:=extractfileext(Filename.text);
  hlpStr:=copy(Filename.text,1,length(Filename.text)-length(hlpStr))+'.eep';
  if fileexists(hlpStr) then
  begin
    Memo1.Text:='Öffne: '+hlpStr;
    PfadEEPROM.text:=hlpStr;
    BitBtn14.visible:=true;
    DatListe.LoadFromFile(hlpStr);
    if (DatListe.count > 0)and(copy(DatListe[0],1,1) = ':') then
      SHOW_iHEX(DatListe, StringGrid2, false)
    else
      SHOW_rawHEX(hlpStr, StringGrid2);
  end;


  DatListe.free;
  screen.cursor:=crdefault;
end;

Procedure TForm1.SET_FUSES_TO_COMBO;
var
  x:integer;
  CKSEL, SUT:string;
begin
  Combobox1.Visible:=Fuses.Read_LockByte;
  if ( Fuses.LockByte and %00000011 ) = %11 then
    Combobox1.ItemIndex:=0
  else
  if ( Fuses.LockByte and %00000010 ) = %10 then
    Combobox1.ItemIndex:=1
  else
    Combobox1.ItemIndex:=2;

  Combobox2.Visible:=Fuses.Read_LockByte;
  if ( Fuses.LockByte and %00001100 ) = %1100 then
    Combobox2.ItemIndex:=0
  else
  if ( Fuses.LockByte and %00001000 ) = %1000 then
    Combobox2.ItemIndex:=1
  else
  if ( Fuses.LockByte and %00000100 ) = %0100 then
    Combobox2.ItemIndex:=3
  else
    Combobox2.ItemIndex:=2;

  Combobox3.Visible:=Fuses.Read_LockByte;
  if ( Fuses.LockByte and %00110000 ) = %110000 then
    Combobox3.ItemIndex:=0
  else
  if ( Fuses.LockByte and %00100000 ) = %100000 then
    Combobox3.ItemIndex:=1
  else
  if ( Fuses.LockByte and %00010000 ) = %010000 then
    Combobox3.ItemIndex:=3
  else
    Combobox3.ItemIndex:=2;

  Combobox4.Visible:=Fuses.Read_LowByte;
  if ( Fuses.LowByte and %10000000 ) = %10000000 then
    Combobox4.ItemIndex:=1
  else
  if ( Fuses.LockByte and %10000000 ) = %0 then
    Combobox4.ItemIndex:=0;

  Combobox5.Visible:=Fuses.Read_LowByte;
  if ( Fuses.LowByte and %01000000 ) = %01000000 then
    Combobox5.ItemIndex:=1
  else
  if ( Fuses.LockByte and %01000000 ) = %0 then
    Combobox5.ItemIndex:=0;

  Combobox6.Visible:=Fuses.Read_LowByte;
  CKSEL:= binStr(  (Fuses.LowByte and %00001111) ,4);
  SUT  := binStr(  ((Fuses.LowByte and %00110000) shr 4) ,2);
  for x := 0 to ComboBox6.Items.count - 1 do
  begin
      if (pos('CKSEL='+CKSEL, ComboBox6.Items[x]) > 0) and (pos('SUT='+SUT, ComboBox6.Items[x]) > 0) then
      begin
        ComboBox6.ItemIndex:=x;
        break;
      end;
  end;


  Combobox7.Visible:=Fuses.Read_HighByte;
  if ( Fuses.HighByte and %10000000 ) = %10000000 then
    Combobox7.ItemIndex:=1
  else
  if ( Fuses.HighByte and %10000000 ) = %00000000 then
    Combobox7.ItemIndex:=0;

  Combobox8.Visible:=Fuses.Read_HighByte;
  if ( Fuses.HighByte and %01000000 ) = %01000000 then
    Combobox8.ItemIndex:=1
  else
  if ( Fuses.HighByte and %01000000 ) = %00000000 then
    Combobox8.ItemIndex:=0;

  Combobox9.Visible:=Fuses.Read_HighByte;
  if ( Fuses.HighByte and %00100000 ) = %00100000 then
    Combobox9.ItemIndex:=1
  else
  if ( Fuses.HighByte and %00100000 ) = %00000000 then
    Combobox9.ItemIndex:=0;

  Combobox10.Visible:=Fuses.Read_HighByte;
  if ( Fuses.HighByte and %00010000 ) = %00010000 then
    Combobox10.ItemIndex:=1
  else
  if ( Fuses.HighByte and %00010000 ) = %00000000 then
    Combobox10.ItemIndex:=0;

  Combobox11.Visible:=Fuses.Read_HighByte;
  if ( Fuses.HighByte and %00001000 ) = %00001000 then
    Combobox11.ItemIndex:=1
  else
  if ( Fuses.HighByte and %00001000 ) = %00000000 then
    Combobox11.ItemIndex:=0;

  Combobox12.Visible:=Fuses.Read_HighByte;
  if ( Fuses.HighByte and %00000110 ) = %00000110 then
    Combobox12.ItemIndex:=0
  else
  if ( Fuses.HighByte and %00000110 ) = %00000100 then
    Combobox12.ItemIndex:=1
  else
  if ( Fuses.HighByte and %00000110 ) = %00000010 then
    Combobox12.ItemIndex:=2
  else
    Combobox12.ItemIndex:=3;

  Combobox13.Visible:=Fuses.Read_HighByte;
  if ( Fuses.HighByte and %00000001 ) = %00000001 then
    Combobox13.ItemIndex:=1
  else
    Combobox13.ItemIndex:=0;
end;

end.

